=== debian/changelog ===
cgal (4.2-5ubuntu1) trusty; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - {libcgal10,libcgal-qt4-10,libcgal-dev,libcgal-qt4-dev}.install.armhf:
      + Don't install files that dont't build on armhf due to GL/GLES skew.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 07 Dec 2013 21:20:51 -0500

cgal (4.2-5) unstable; urgency=low

  * Add Replaces: libcgal-dev (<< 4.1-1), Breaks: libcgal-dev (<< 4.1-1) to
    libcgal-qt4-dev (Closes: #718006).
  * Update Standards-Version to 3.9.3 (no changes needed).
  * Removed hardening-no-fortify-functions from lintian overrides for
    libcgal-qt4-10 and libcgal-ipelets. Added spelling-error-in-binary to
    lintian overrides for libcgal-ipelets.

 -- Joachim Reichel <reichel@debian.org>  Sun, 28 Jul 2013 10:32:39 +0200

cgal (4.2-4ubuntu2) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 18:08:36 +0100

cgal (4.2-4ubuntu1) saucy; urgency=low

  * {libcgal10,libcgal-qt4-10,libcgal-dev,libcgal-qt4-dev}.install.armhf:
    - Don't install files that dont't build on armhf due to GL/GLES skew.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 05 Jul 2013 16:57:50 -0600

cgal (4.2-4build1) saucy; urgency=low

  * Rebuild against libipe7.1.3.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 25 Jun 2013 13:39:34 +0100

cgal (4.2-4) unstable; urgency=low

  * Fix FTBFS on i386, hurd-i386, and kfreebsd-i386 caused by missing
    handling of excess FPU precision in recently added test
    rounding_math_simple.cpp.
  * Add patch fix-fpu-rounding-modes-ia64 to fix FTBFS on ia64.
  * Remove -DWITH_NTL=ON from cmake configuration for CGAL ipelets (not
    needed).

 -- Joachim Reichel <reichel@debian.org>  Tue, 21 May 2013 22:59:05 +0200

cgal (4.2-3) unstable; urgency=low

  * Change Recommends: libcgal10-qt4 of libcgal-demo to the correct
    package name libcgal-qt4-10.
  * Add a stand-alone test extracted from Interval_nt.h (fails on ia64).
  * Update Standards-Version to 3.9.4 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Mon, 20 May 2013 13:30:38 +0200

cgal (4.2-2) unstable; urgency=low

  * Upload to unstable.

 -- Joachim Reichel <reichel@debian.org>  Wed, 08 May 2013 22:20:14 +0200

cgal (4.2-1) experimental; urgency=low

  * New upstream release.
  * Add libboost-system-dev to Depends: of libcgal-dev.

 -- Joachim Reichel <reichel@debian.org>  Thu, 11 Apr 2013 22:09:02 +0200

cgal (4.1-2) experimental; urgency=low

  * Enable NTL support.
  * Re-enable test for proper FPU rounding-mode support.

 -- Joachim Reichel <reichel@debian.org>  Thu, 07 Feb 2013 20:40:30 +0100

cgal (4.1-1) unstable; urgency=low

  * New upstream release.
  * Rename binary package libcgal9 to libcgal10 to reflect SONAME change.
  * Configure CGAL using -DCGAL_ENABLE_PRECONFIG=OFF since we do not want
    that the accidential presence of optional libraries (for demos and
    examples) influences the build of the library.
  * Move the Qt4 support library and the corresponding headers into new
    binary packages libcgal-qt4-10 and libcgal-qt4-dev (Closes: #683214).
  * Add libboost-system-dev to Builds-Depends: of cgal.
  * Move libmpfi-dev from Suggests: of cgal-demo to Build-Depends: of cgal.

 -- Joachim Reichel <reichel@debian.org>  Wed, 24 Oct 2012 19:08:35 +0200
