=== debian/watch ===
# Note that the file URLs contain unpredictable IDs as directory. The
# uversionmagle options strips this ID.
#
# Note that only digits and "." are used to match the version number.
# Therefore we do not match beta releases.
#
version=3
opts=uversionmangle=s/(\d+).([\d\.]+)/$2/ \
  https://gforge.inria.fr/frs/?group_id=52 \
  /frs/download.php/(\d+)/CGAL-([\d\.]+).tar.gz
